<?php

class Franchiseandstorelocator extends Tools_Plugins_Abstract {

    const FRANCHISEANDSTORELOCATOR_SECURE_TOKEN = 'FranchiseandstorelocatorToken';

	public function  __construct($options, $seotoasterData) {
		parent::__construct($options, $seotoasterData);

        $this->_layout = new Zend_Layout();
        $this->_layout->setLayoutPath(Zend_Layout::getMvcInstance()->getLayoutPath());

        if(($scriptPaths = Zend_Layout::getMvcInstance()->getView()->getScriptPaths()) !== false) {
            $this->_view->setScriptPath($scriptPaths);
        }
        $this->_view->addScriptPath(__DIR__ . '/system/views/');
    }
    
	public function run($requestedParams = array()) {
        $dispatchersResult = parent::run($requestedParams);
		if($dispatchersResult) {
			return $dispatchersResult;
		}
    }


    public function _makeOptionZips()
    {
        $pageId = $this->_seotoasterData['id'];
        $mapperDealer = Franchiseandstorelocator_Models_Mapper_FranchisedataMapper::getInstance();
        $dealerInfo = $mapperDealer->getDealerDataByPid($pageId);
        $zips = '';
        if (!empty($dealerInfo)) {
            foreach ($dealerInfo as $key => $dealerInf) {
                $zips .= $dealerInf->getZip() . ',';
            }

            return rtrim($zips, ',');
        }

        return '';
    }

    
     public function _makeOptionDform(){
         if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)) {
            $pageId = $this->_seotoasterData['id'];
            $mapperDealer = Franchiseandstorelocator_Models_Mapper_FranchisedataMapper::getInstance();
            $daelerInfos = $mapperDealer->getDealerDataByPid($pageId);
            $pageUrl = '';
            $zips = '';
            foreach($daelerInfos as $key=>$daelerInfo){
                $dilerinfo[$key]['zip'] = $daelerInfo->getZip();
                $dilerinfo[$key]['url'] = $daelerInfo->getUrl();
                $dilerinfo[$key]['pid'] = $daelerInfo->getPid();
            }
            if(!empty($dilerinfo)){
                $zips = array();
                for($i=0; $i<count($dilerinfo); $i++){
                    $zips[$i] = $dilerinfo[$i]['zip'];
                }
                $zips = implode(',', $zips);
                if($dilerinfo['0']['url'] == NULL) {
                    $pidUrl = $mapperDealer->getDealerDataByPid($pageId);
                    $pageUrlLink = $pidUrl[0]->getUrl();
                    if (!empty($pageUrlLink)) {
                        $pageUrl = $this->_websiteUrl.$pidUrl[0]->getUrl();
                    }

                } else {
				    $pageUrl = $dilerinfo['0']['url'];
			    }
           }
           $this->_view->pageId = $pageId;
           $this->_view->translator = $this->_translator;
           $this->_view->zips = $zips;
		   $this->_view->url = $pageUrl;
		   return $this->_view->render("dealerform.phtml");
         }
     }
    
     public function _makeOptionSform(){
         $this->_view->translator = $this->_translator;
         return $this->_view->render("zipsearch.phtml");
     }

     public function saveDealerAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)){
            $secureToken = $this->_request->getParam(Tools_System_Tools::CSRF_SECURE_TOKEN, false);
            $tokenValid = Tools_System_Tools::validateToken($secureToken, self::FRANCHISEANDSTORELOCATOR_SECURE_TOKEN);
            if (!$tokenValid) {
                $this->_responseHelper->fail('');
            }
            $zipDealer = trim($this->_request->getParam('zipDealer'));
            $webSiteDealer = trim($this->_request->getParam('webSiteDealer'));
            $pageId = trim($this->_request->getParam('pageIdVal'));
            $mapperDealer = Franchiseandstorelocator_Models_Mapper_FranchisedataMapper::getInstance();
            $modelDealer  = new Franchiseandstorelocator_Models_Models_FranchisedataModel();
            $mapperDealer->clearDealerZip($pageId);
            $zips = explode(',', $zipDealer);
            if($webSiteDealer == ''){
                $webSiteDealer = null;
            }
            foreach($zips as $zip) {
                if(empty($zip)) {
                    continue;
                }
                $zipExists = $mapperDealer->getDealerDataByZip($zip);
                if (empty($zipExists)) {
                    $modelDealer->setPid($pageId);
                    $modelDealer->setZip(trim($zip));
                    $modelDealer->setUrl($webSiteDealer);
                    $mapperDealer->save($modelDealer);
                } else {
                    $pageWithZip = Application_Model_Mappers_PageMapper::getInstance()->find($zipExists[0]->getPid());
                    if ($pageWithZip instanceof Application_Model_Models_Page) {
                        $this->_responseHelper->fail($this->_translator->translate('Zip already exists') . ' <a target="_blank" href="' . $this->_websiteUrl . $pageWithZip->getUrl() . '">' . $zip . '</a>');
                    } else {
                        $this->_responseHelper->fail($this->_translator->translate('Zip already exists') . ' ' . $zip);
                    }

                }
            }
            $this->_responseHelper->success($this->_translator->translate('All zips added.'));
        }
    }
    
    public function searchZipAction(){
       $zipForSearch = filter_var(trim($this->_request->getParam('zipForSearch')), FILTER_SANITIZE_STRING);
       $mapperDealer = Franchiseandstorelocator_Models_Mapper_FranchisedataMapper::getInstance();
       $mapperConfig = Franchiseandstorelocator_Models_Mapper_FranchisesettingsMapper::getInstance();
       $pageMapper = Application_Model_Mappers_PageMapper::getInstance();
       $searchResult = $mapperDealer->getDealerDataByZip($zipForSearch);
       $franchiseConfig = $mapperConfig->getConfigParams();
       if(!empty($searchResult)) {
			if(isset($franchiseConfig['autoR']) &&  $franchiseConfig['autoR'] == 1 && $searchResult[0]->getUrl() != ''){
				if(!preg_match('~http:\/\/~', $searchResult[0]->getUrl())){
                    $this->_redirector->gotoUrl('http://'.$searchResult[0]->getUrl(),array('exit' => true));
                }else{
                    $this->_redirector->gotoUrl($searchResult[0]->getUrl(),array('exit' => true));
                }
            }
			else {
				$pidUrl = $pageMapper->find($searchResult[0]->getPid());
                $pageUrl = $this->_websiteUrl.$pidUrl->getUrl();
                $this->_redirector->gotoUrl($pageUrl,array('exit' => true));
			}
	   }
	   else {
			if(isset($franchiseConfig['cPageId'])){
                $pidUrl = $pageMapper->find($franchiseConfig['cPageId']);
                $pageUrl = $this->_websiteUrl.$pidUrl->getUrl();
                $this->_redirector->gotoUrl($pageUrl,array('exit' => true));
            }
            $this->_redirector->gotoUrl($this->_websiteUrl,array('exit' => true));
       }
    }

   
    public function configAction(){
        if(Tools_Security_Acl::isAllowed(Tools_Security_Acl::RESOURCE_PLUGINS)){
            $franchiseConfigMapper = Franchiseandstorelocator_Models_Mapper_FranchisesettingsMapper::getInstance();
            if($this->_request->isPost()){
                $secureToken = $this->_request->getParam(Tools_System_Tools::CSRF_SECURE_TOKEN, false);
                $tokenValid = Tools_System_Tools::validateToken($secureToken, self::FRANCHISEANDSTORELOCATOR_SECURE_TOKEN);
                if (!$tokenValid) {
                    $this->_responseHelper->fail('');
                }
                $configParams = $this->_request->getParams();
                $franchiseConfigMapper->save($configParams);
                $this->_responseHelper->success('');
            }else{
                $franchiseSettings = $franchiseConfigMapper->getConfigParams();
                $pageMapper = Application_Model_Mappers_PageMapper::getInstance();
                $productCategoryPage = $pageMapper->findByUrl('product-pages.html');
                if($productCategoryPage instanceof Application_Model_Models_Page){
                    $productCategoryId = $productCategoryPage->getId();
                    $where = $pageMapper->getDbTable()->getAdapter()->quoteInto("parent_id <> '?'", $productCategoryId);
                    $pages = $pageMapper->fetchAll($where);
                }else{
                    $pages = $pageMapper->fetchAll();
                }
                $this->_view->pages = $pages;
                $this->_view->settings = $franchiseSettings;
                $this->_view->translator = $this->_translator;
                $this->_layout->content = $this->_view->render('config.phtml');
                echo $this->_layout->render();
            }
            
        }
    }
                  
}

